%define	compiler gcc
%define destdir_top  /usr/local/rnpletal
%define destdir  /usr/local/rnpletal/%{compiler}
%define modulefile_path_top /usr/local/share/Modules/modulefiles/rnpletal
%define modulefile_path /usr/local/share/Modules/modulefiles/rnpletal/%{compiler}

Name:		rnpletal
Version:	0.1
Release:	1%{?dist}
Summary:	RNPL/xvs/DV

Group:		Scientific/Applications
License:	Various
URL:		http://laplace.phas.ubc.ca/Doc/rnpletal/
Source0:	DV.tar.gz
Source1:	mpeg_encode-1.5c.tar.gz
Source2:	rnpletal.tar.gz
Source3:	xforms-1.0.tar.gz
Source4:	xvs.tar.gz
Patch1:		xforms.puiasfixes

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	libjpeg-devel imake libXpm-devel libXext-devel libX11-devel libGL-devel 
BuildRequires:  libtiff-devel mesa-libGLU-devel
BuildRequires:  gcc-gfortran flex bison 

%description
RNPL/xvs/DV

%prep
%setup -q -c -T -a 0 -a 1 -a 2 -a 3 -a 4
%patch1 -p0 -b .puiasfixes
# fix up the default DV opts location
perl -pi -e 's|/usr/local/lib/DV/default_opts.dvo|%{destdir}/lib/DV/default_opts.dvo|g' DV/DV_gui/DV_gui.c

%build
TIP=`pwd`/TEMPINSTALLPATH
mkdir $TIP
pushd $TIP
mkdir bin include lib
%if "%{_lib}" != "lib"
ln -s lib %{_lib}
%endif 
popd
export PATH=$TIP/bin:$PATH
export LD_LIBRARY_PATH=$TIP/lib
export LIBRARY_PATH=$TIP/lib
export LDFLAGS="-L$TIP/lib"
export INCLUDE="-I$TIP/include"
export CPATH="$TIP/include"
export FFLAGS="-I$TIP/include"
export INCLUDE_PATHS="$TIP/include $TIP/include/X11"
# in proper order please
pushd rnpletal
./Install.gnu $TIP
popd
pushd xforms-1.0
xmkmf -a 
make install DESTDIR=$TIP
cd $TIP/usr
mv %{_lib}/lib*a ../lib/
rm -rf %{_lib}
mv include/* ../include/
mv bin/* ../bin/
rmdir *
cd ..
rmdir usr
ln -s . usr
popd
pushd mpeg_encode-1.5c/
./configure --prefix=$TIP
make install
popd
pushd xvs
export F77=gfortran
./configure --prefix=$TIP
make install
popd
pushd DV
./configure --prefix=$TIP
make install
popd

%install
rm -rf $RPM_BUILD_ROOT
TIP=`pwd`/TEMPINSTALLPATH
mkdir -p $RPM_BUILD_ROOT/%{destdir}/{bin,man/man1,include,lib}
for i in bin man include lib; do
	mkdir -p $RPM_BUILD_ROOT/%{destdir}/$i
	mv $TIP/$i/* $RPM_BUILD_ROOT/%{destdir}/$i/
done
%if "%{_lib}" != "lib"
pushd $RPM_BUILD_ROOT/%{destdir}
ln -s lib "%{_lib}"
%endif

mkdir -p $RPM_BUILD_ROOT/%{modulefile_path}
cat <<ENDMODULE > ${RPM_BUILD_ROOT}%{modulefile_path}/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds %{name} %{version} for %{compiler} various paths"
}

module-whatis   "Sets up %{name} %{version} for %{compiler} in your environment"

prepend-path PATH "%{destdir}/bin"
prepend-path LD_LIBRARY_PATH "%{destdir}/lib"
prepend-path LIBRARY_PATH "%{destdir}/lib"
prepend-path MANPATH "%{destdir}/man"
append-path -d { } LDFLAGS "-L%{destdir}/lib"
append-path -d { } INCLUDE "-I%{destdir}/include"
append-path CPATH "%{destdir}/include"
append-path -d { } FFLAGS "-I%{destdir}/include"
append-path -d { } LOCAL_LDFLAGS "-L%{destdir}/lib"
append-path -d { } LOCAL_INCLUDE "-I%{destdir}/include"
append-path -d { } LOCAL_CFLAGS "-I%{destdir}/include"
append-path -d { } LOCAL_FFLAGS "-I%{destdir}/include"
ENDMODULE

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{destdir_top}
%{destdir}
%dir %{modulefile_path_top}
%dir %{modulefile_path}
%{modulefile_path}/%{version}

%changelog
* Thu Mar 22 2012 Josko Plazonic <plazonic@math.princeton.edu>
- initial build
